=== debian/changelog ===
llvm-toolchain-18 (1:18.1.3-1ubuntu1) noble; urgency=medium

  * Disable mold for all to make sure it builds gold (LP: #2064187)
  * Be explicit with what ships in llvm-18-linker-tools to make sure we always
    ship gold

 -- Shengjing Zhu <shengjing.zhu@canonical.com>  Mon, 27 May 2024 16:26:20 +0800

llvm-toolchain-18 (1:18.1.3-1) unstable; urgency=medium

  * New upstream release
  * Only install mold when used
    but disabled for now because of https://github.com/rui314/mold/issues/1224

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 04 Apr 2024 07:57:13 +0200

llvm-toolchain-18 (1:18.1.2-1) unstable; urgency=medium

  [ Matthias Klose ]
  * Build-depend on llvm-spirv-18 instead of llvm-spirv-17.
  * Add a stage1 profile to disable curl, grpc and spirv.
  * Build with --as-needed.

  [ Sylvestre Ledru ]
  * New upstream release
  * Build using mold as a linker

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 22 Mar 2024 21:24:08 +0100

llvm-toolchain-18 (1:18.1.1-1) unstable; urgency=medium

  [ Matthias Klose ]
  * Fix sanitizer build on 32bit time_t64 architectures.
  * Enable compiler-rt runtime again for 32bit time_t64 architectures.
  * Revert: mark profile and xray include files as optional on armel and armhf.

  [ Sylvestre Ledru ]
  * Disable libc on bionic for apt.llvm.org
  * Try to address a link issue with libclang-cpp.so.18 (GH: #83986)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 08 Mar 2024 20:27:05 +0100

llvm-toolchain-18 (1:18.1.0-2) unstable; urgency=medium

  * Uncomment wrong removal of rm code from last upload.
    - this should fix the current FTBFS

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 06 Mar 2024 21:49:10 +0100

llvm-toolchain-18 (1:18.1.0-1) unstable; urgency=medium

  * New stable release
  * Add a test to verify C++ modules tests

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 06 Mar 2024 11:29:56 +0100

llvm-toolchain-18 (1:18.1.0~rc4-2) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * Disable libllvmlibc-18-dev on armhf (Closes: #1065503)
  * Adjust some symlinks with the rc4 changes

  [ Matthias Klose ]
  * Make libclang-common-18-dev architecture dependent, mark profile and xray
    include files as optional on armel and armhf.

  [ Gianfranco Costamagna ]
  * Simplify rules file now that time64_t is default.
  * Use mxgot on mips64el
  * Disable tests on mips64el, they do timeout

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 06 Mar 2024 09:21:57 +0100

llvm-toolchain-18 (1:18.1.0~rc4-1) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Install *clang_rt* on sparc and sparc64
  * Run chrpath for libclang on sparc and sparc64

  [ Sylvestre Ledru ]
  * New snapshot release
  * add -DLIBCXX_INSTALL_MODULES=ON to install libc++ C++-20 modules
    see https://discourse.llvm.org/t/libc-c-23-module-installation-support/77061/1
  * Add a new package libllvmlibc-18-dev to ship LLVM libc (experimental for now)
    (amd64, arm64 and armhf)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 28 Feb 2024 11:08:41 +0100

llvm-toolchain-18 (1:18.1.0~rc2-4) unstable; urgency=medium

  * Fix 32bit builds, exclude i386, don't build clang-rt there
  * Revert gold linker on mips64el
  * Disable stack protector on mips64el

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 22 Feb 2024 17:58:05 +0100

llvm-toolchain-18 (1:18.1.0~rc2-3) unstable; urgency=medium

  * Add abi=+time64,+lfs only on 64bits system

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 11 Feb 2024 14:29:31 +0100

llvm-toolchain-18 (1:18.1.0~rc2-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Try gold linker on mips64el
  * Add also lfs on top of time64, to fix FTBFS on 32bit

  [ Sylvestre Ledru ]
  * add new symbols in libomp5

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 08 Feb 2024 16:38:35 +0100

llvm-toolchain-18 (1:18.1.0~rc2-1) unstable; urgency=medium

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 07 Feb 2024 21:15:53 +0100

llvm-toolchain-18 (1:18.1.0~rc1-3) unstable; urgency=medium

  * Fix previus upload, time64 is effective only in one specific place of
    rules file
  * Fix some test using still clang-17
  * Switch testing to 18 line
  * Fix an underlinking on qualify-clang.sh

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 07 Feb 2024 15:05:08 +0100

llvm-toolchain-18 (1:18.1.0~rc1-2) unstable; urgency=medium

  [ Steve Langasek ]
  * Use ABI time64 to avoid a transition for a new package

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 05 Feb 2024 08:26:26 +0100

llvm-toolchain-18 (1:18.1.0~rc1-1) unstable; urgency=medium

  [ Samuel Thibault ]
  * control: Avoid hello build-dep getting pulled in on buildds.

  [ Gianfranco Costamagna ]
  * Fixup rc versioning, and go for sid

  [ Sylvestre Ledru ]
  * hwasan_symbolize is now built also on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Jan 2024 10:36:07 +0100

llvm-toolchain-18 (1:18.1.0-rc1-1~exp1) experimental; urgency=medium

  * First RC

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 30 Jan 2024 09:01:06 +0100

llvm-toolchain-18 (1:18.1.0~++20240126095841+0991d3c7b53d-1~exp1) experimental; urgency=medium

  * Branching of 18
    note that it is normal that the versionning starts from 18.1
    See https://discourse.llvm.org/t/rfc-name-the-first-release-from-a-branch-n-1-0-instead-of-n-0-0/75384
  * refresh libomp5 symbol list
  * For the usage of -DLIBCXXABI_USE_LLVM_UNWINDER=OFF when we don't build unwind
    https://github.com/llvm/llvm-project/issues/77846
  * remove the unconditionnaly defined -DLIBUNWIND_USE_COMPILER_RT=ON
  * Also pass -DLIBCXXABI_USE_LLVM_UNWINDER:BOOL=OFF to libcxx-wasm32-wasi builds

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 26 Jan 2024 09:44:56 +0100

llvm-toolchain-snapshot (1:18~++20231211102647+75193b192ad9-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * Set the cpu defaults for the ARM32 architectures:

